<?php

namespace Teknisa\DF\Controllers;

use Zeedhi\Framework\DTO;

class NotafiscalLancamento extends \Teknisa\DF\Controllers\TeknisaCrud
{
    const DATASOURCE_NOTAFISCAL_FORN = 'notafiscal_fornecedor_lancamento_saida';
    const DATASOURCE_NOTAFISCAL_CLIE = 'notafiscal_cliente_lancamento_saida';
    const DATASOURCE_NOTAFISCAL_FILI = 'notafiscal_filial_lancamento_saida';

    protected $dataSourceName = 'notafiscal_lancamento';
    protected $parameterBagColumns = array(
        'P_IDENTRSAIDOP',
        'P_IDSTATUS',
        'P_CDFILIEMIT',
        'P_CDEMPRESA',
        'P_IDORIGDESTNF',
        'P_NRINSJURNF',
        'P_DTEMISSAOINI',
        'P_DTEMISSAOFIM',
        'P_DTENTRSAIDINI',
        'P_DTENTRSAIDFIM',
        'P_TDTEMISSAO',
        'P_CDSERIE'
    );

    public function find(DTO\Request\Filter $request, DTO\Response $response) {

        $filterCriteria = $request->getFilterCriteria();
        $conditions = $filterCriteria->getConditions();

        $keyRemoveIdorigdestnf = null;

        foreach ($conditions as $key => $condition) {

            if ($condition['columnName'] === 'IDORIGDESTNF') {

                $idorigdestnf = str_split($condition['value']);

                switch ($idorigdestnf) {
                    case in_array('F', $idorigdestnf):
                        $this->dataSourceName = self::DATASOURCE_NOTAFISCAL_FORN;
                        break;
                    case in_array('C', $idorigdestnf):
                        $this->dataSourceName = self::DATASOURCE_NOTAFISCAL_CLIE;
                        break;
                    case in_array('L', $idorigdestnf):
                        $this->dataSourceName = self::DATASOURCE_NOTAFISCAL_FILI;
                        break;
                }
                $keyRemoveIdorigdestnf = $key;
            }
        }

        if (is_numeric($keyRemoveIdorigdestnf))
            array_splice($conditions, $keyRemoveIdorigdestnf, 1);

        parent::find($request, $response);
    }
}